



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JVM 运行时数据区详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JVM 运行时数据区详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 18:55:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>一、运行时数据区</h3>
<p>　　Java虚拟机在执行Java程序的过程中会把它所管理的内存划分为若干个不同数据区域。</p>
<p>　　　　1.有一些是随虚拟机的启动而创建，随虚拟机的退出而销毁，所有的线程共享这些数据区。</p>
<p>　　　　2.第二种则是与线程一一对应，随线程的开始和结束而创建和销毁，线程之间相互隔离。</p>
<p>　　Java虚拟机所管理的内存将会包括以下几个运行时数据区域</p>
<p>　　　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/894443/201703/894443-20170305170649016-851733106.png" /></p>
<h3>二、数据区详解</h3>
<p>1.<strong>程序计数器(<strong>Program Counter Register</strong>)</strong></p>
<ul><li>也叫PC寄存器是一块较小的内存空间，它的作用是存储当前线程所执行的字节码的信号指示器。</li>
<li>每一条JVM线程都有自己的PC寄存器。</li>
<li>在任意时刻，一条JVM线程只会执行一个方法的代码。该方法称为该线程的当前方法（Current Method）。</li>
<li>如果该方法是java方法，那PC寄存器保存JVM正在执行的字节码指令的地址。</li>
<li>如果该方法是native，那PC寄存器的值是undefined。</li>
<li>此内存区域是唯一一个在Java虚拟机规范中没有规定任何OutOfMemoryError情况的区域。</li></ul>
<p>2.<strong>Java</strong><strong>虚拟机栈(Java Virtual Machine Stack)</strong></p>
<ul><li>每一个JVM线程都有自己的java虚拟机栈，这个栈与线程同时创建，它的生命周期与线程相同。</li>
<li>用于存储局部变量、操作栈、动态链接、方法出口</li>
<li>虚拟机栈描述的是Java方法执行的内存模型：
<ul><li>每个方法被执行的时候都会同时创建一个栈帧（Stack Frame）用于存储局部变量表、操作数栈、动态链接、方法出口等信息。</li>
<li>每一个方法被调用直至执行完成的过程就对应着一个栈帧在虚拟机栈中从入栈到出栈的过程。</li>
<li>局部变量表存放了编译器克制的各种基本数据类型（boolean、byte、char、short、int、float、long、double）、对象引用（Object reference）和字节码指令地址（returnAddress类型）。</li></ul></li>
<li>JVM stack&nbsp;可以被实现成固定大小，也可以根据计算动态扩展。
<ul><li>如果采用固定大小的JVM stack设计，那么每条线程的JVM Stack容量应该在线程创建时独立地选定。</li>
<li>JVM实现应该提供调节JVM Stack初始容量的手段。</li>
<li>如果采用动态扩展和收缩的JVM Stack方式，应该提供调节最大、最小容量的手段。</li></ul></li>
<li>对于32位的jvm，默认大小为256kb, 而64位的jvm, 默认大小为512kb,可以通过<strong>-Xss设置虚拟机栈的最大值</strong>。不过如果设置过大，会影响到可创建的线程数量。</li>
<li>JVM Stack&nbsp;异常情况：
<ul><li>StackOverflowError：当线程请求分配的栈容量超过JVM允许的最大容量时抛出.</li>
<li>OutOfMemoryError：如果JVM Stack可以动态扩展，但是在尝试扩展时无法申请到足够的内存去完成扩展，或者在建立新的线程时没有足够的内存去创建对应的虚拟机栈时抛出。</li></ul></li></ul>
<p>3.<strong>本地方法栈(Native Method Stack)</strong></p>
<ul><li>Java虚拟机可能会使用到传统的栈来支持native方法（使用Java语言以外的其它语言编写的方法）的执行，这个栈就是本地方法栈.</p>
<ul><li>如果JVM不支持native方法，也不依赖与传统方法栈的话，可以无需支持本地方法栈。</li>
<li>如果支持本地方法栈，则这个栈一般会在线程创建的时候按线程分配。</li></ul></li>
<li>异常情况：
<ul><li>StackOverflowError：如果线程请求分配的栈容量超过本地方法栈允许的最大容量时抛出.</li>
<li>OutOfMemoryError：如果本地方法栈可以动态扩展，并且扩展的动作已经尝试过，但是目前无法申请到足够的内存去完成扩展，或者在建立新的线程时没有足够的内存去创建对应的本地方法栈，那Java虚拟机将会抛出一个OutOfMemoryError异常。</li></ul></li></ul>
<p><strong>注：以上三个数据区属于各个线程单享的，每个线程创建时都会创建此三个数据区。各个线程之间相互隔离，互不影响。</strong></p>
<p>4.<strong>方法区(<strong>Method Area</strong>)</strong></p>
<ul><li>方法区是可供各条<strong>线程共享</strong>的运行时内存区域。存储了每一个类的结构信息，例如:运行时常量池(Runtime Constant Pool)、字段和方法数据、构造函数和普通方法的字节码内容、还包括一些在类、实例、接口初始化时用到的特殊方法。</li>
<li>方法区在虚拟机启动的时候创建。</li>
<li>方法区的容量可以是固定大小的，也可以随着程序执行的需求动态扩展，并在不需要过多空间时自动收缩。</li>
<li>方法区在实际内存空间中可以是不连续的。</li>
<li>Java虚拟机实现应当提供给程序员或者最终用户调节方法区初始容量的手段，对于可以动态扩展和收缩方法区来说，则应当提供调节其最大、最小容量的手段。</li>
<li>Java&nbsp;方法区异常：
<ul><li>OutOfMemoryError：&nbsp;如果方法区的内存空间不能满足内存分配请求，那Java虚拟机将抛出一个OutOfMemoryError异常。</li></ul></li></ul>
<p><strong>运行时常量池（</strong><strong>Runtime Constant Pool</strong><strong>）</strong></p>
<ul><li>运行时常量池是每一个类或接口的常量池（Constant_Pool）的运行时表现形式，它包括了若干种常量：编译器可知的数值字面量到必须运行期解析后才能获得的方法或字段的引用。</li>
<li>运行时常量池是方法区的一部分。每一个运行时常量池都分配在JVM的方法区中，在类和接口被加载到JVM后，对应的运行时常量池就被创建。</li>
<li>在创建类和接口的运行时常量池时，可能会遇到的异常：
<ul><li>OutOfMemoryError：创建类和接口时，若构造运行时常量池所需的内存空间超过了方法区所能提供的最大内存空间后时抛出.</li></ul></li></ul>
<p>5.<strong>Java</strong><strong>堆(Heap)</strong></p>
<ul><li>在JVM中，堆是可供各条<strong>线程共享</strong>的运行时内存区域，也是供所有类实例和数据对象分配内存的区域。</li>
<li>Java堆是Java虚拟机所管理的内存中最大的一块。</li>
<li>通过-Xms和-Xmx来控制初始堆大小和最大堆大小</li>
<li>Java堆载虚拟机启动的时候就被创建，堆中储存了各种对象，这些对象被自动管理内存系统（Automatic Storage Management System，也即是常说的&ldquo;Garbage Collector（垃圾回收器）&rdquo;）所管理。这些对象无需、也无法显示地被销毁。</li>
<li>Java堆的容量可以是固定大小，也可以随着需求动态扩展，并在不需要过多空间时自动收缩。</li>
<li>Java堆所使用的内存不需要保证是物理连续的，只要逻辑上是连续的即可。</li>
<li>JVM实现应当提供给程序员调节Java&nbsp;堆初始容量的手段，对于可动态扩展和收缩的堆来说，则应当提供调节其最大和最小容量的手段。</li>
<li>Java&nbsp;堆异常：
<ul><li>OutOfMemoryError：如果实际所需的堆超过了自动内存管理系统能提供的最大容量时抛出。</li></ul></li></ul>
<blockquote><p>参考原文：http://chenzhou123520.iteye.com/blog/1585224</p>
<p>　　　　　http://www.open-open.com/lib/view/open1383745340321.html</p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdog4z8.html">Java IO教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r1kd78.html">什么是Ajax</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kerej8.html">html5 -js判断undefined类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96635n9.html">HTML5 ：b&sol;strong加粗，i&sol;em倾斜区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjn3xy9.html">T-sql语句中GO的作用及语法【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdd55m8.html">GitHub上不错的Android开源项目（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0zkm0q.html">Android Studio导入Project的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvexmxq.html">Asp&period;Net 操作word 第二篇&lbrack;推荐&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd4wmr8.html">React可控组件与不可控组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wx72vq.html">js的for in具有不适应性（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mn0ggq.html">碎片化时代：O2O服务成最大趋势</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v4gk48.html">Clone中存在的浅克隆问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mpkjkq.html">PHP学习笔记7-JSON数据操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yd6mz8.html">闭包用法，延迟tab</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj5o1e9.html">每天一个linux命令&lpar;48&rpar;--ln命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj7n0xq.html">网易云歌词解析&lpar;配合audio标签实现本地歌曲播放&comma;歌词同步&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ozk0k8.html">MySQL设置global变量和session变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyy6wjq.html">Python学习笔记【第九篇】：Python面向对象基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7on15j8.html">错误 java&period;lang&period;ClassCastException&colon; com&period;xx cannot be cast to ResourceBundle</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r4gp58.html">flex外包团队&mdash;北京动点软件：推荐一本不错的Flex书籍</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4jxwn3q.html">git windows下载安装 &lpar;git命令&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyypxomq.html">spring注解开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/90ro0239.html">5、Makefile基础知识汇总（转自陈皓总述）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv6p5z8.html">bzoj 2440 完全平方数 【莫比乌斯函数】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5orx7q.html">Android-Recyclerview-使用分割线</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w54gzq.html">Linux 下建立 SSH 隧道做 Socket 代理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyypk2gq.html">利用GDI&plus;处理图像的色彩</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jxlkjq.html">javascript实现OOP编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5oomeq.html">深入字节码理解invokeSuper无限循环的原因</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2xxly9.html">Oracle11g手动创建数据库方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
